#!/bin/sh

if [ $# -lt 1 ]; then
  echo "Please input the FPGA ID " 
  echo "sh ./xbinst_oem/tool/faas_checkstatus.sh [FPGA ID 0~3]"
  echo " " 
  exit 1
fi

YourInstanceId=`curl -s http://100.100.100.200/latest/meta-data/instance-id`
echo ${YourInstanceId}
# try capture error during list_instances
faascmd list_instances --instanceId=${YourInstanceId} > .listinstanceoutput.txt

fpga_num=$1
FpgaUUID="$(jq -r --arg index ${fpga_num} '[.Instances.instance[].FpgaUUID]|.[$index|tonumber]' .listinstanceoutput.txt)"
faascmd fpga_status --fpgauuid=${FpgaUUID} --instanceId=${YourInstanceId}

rm -r .listinstanceoutput.txt
